-- ------------------------------------------------------------------------------ --
--                                TradeSkillMaster                                --
--                          https://tradeskillmaster.com                          --
--    All Rights Reserved - Detailed license information included with addon.     --
-- ------------------------------------------------------------------------------ --

local TSM = select(2, ...) ---@type TSM
local Types = TSM.Init("Service.SettingsClasses.Types") ---@class Service.SettingsClasses.Types
local ClientInfo = TSM.LibTSMWoW:Include("Util.ClientInfo")
local SessionInfo = TSM.LibTSMWoW:Include("Util.SessionInfo")

---@alias ScopeName
---|'"global"'
---|'"profile"'
---|'"realm"'
---|'"factionrealm"'
---|'"char"'
---|'"sync"'

---@alias ScopeKey
---|'"g"'
---|'"p"'
---|'"r"'
---|'"f"'
---|'"c"'
---|'"s"'

---@type table<ScopeName, ScopeKey>
Types.SCOPES = {
	global = "g",
	profile = "p",
	realm = "r",
	factionrealm = "f",
	char = "c",
	sync = "s",
}

---@type table<ScopeKey, ScopeName>
Types.SCOPES_LOOKUP = {
	g = "global",
	p = "profile",
	r = "realm",
	f = "factionrealm",
	c = "char",
	s = "sync",
}

Types.ACCESSIBLE_FACTIONS = ClientInfo.HasFeature(ClientInfo.FEATURES.CONNECTED_FACTION_AH) and {
	"Horde",
	"Alliance",
	"Neutral"
} or { SessionInfo.GetFactionName() }

Types.KEY_SEP = "@"
Types.SCOPE_KEY_SEP = " - "

Types.GLOBAL_SCOPE_KEY = " "
Types.GLOBAL_SCOPE_KEY_VALUES = {Types.GLOBAL_SCOPE_KEY}

Types.DEFAULT_PROFILE_NAME = "Default"
